/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * Laboratorul 1
 * Digital I/O
 *********************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h> 
#define F_CPU 16000000
#include <util/delay.h>

/*
DDRC =  0xFF;      PORTC | =1 <<(PC5)

bit_set(PORTC,PC5)
bit_clr(PORTC,PC5)

	DDRC = 0xFF;
	PORTC |=1 <<(PC5) ;
*/
#define bit_set(var,bitno) var |= 1 << bitno
#define bit_clr(var,bitno) var &= ~(1 << bitno)

void InitADC() {
	// Aref = AVic
	ADMUX = (1<<REFS0) ;
	// factor = 128
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0) ;
}

uint16_t ReadADC(uint8_t ch) {
	// selectare canal ADC
	ch = ch & 0b00000111 ;  
	DDRA = 0x00 ;
	ADMUX = ADMUX | ch ; 

	// porneste conversia 
	ADCSRA = ADCSRA | (1<<ADSC) ; 

	// astept sa se faca conversia
	while ( !(ADCSRA & (1<<ADIF)) ) ;

	// Sterg ADIF punand 1 ( in cod scriu '1', dar in rezultat bitul e setat '0' )
	ADCSRA = ADCSRA | (1<<ADIF) ;

	return ADC ;
}

int main() {
	uint16_t adc_result ;
	uint8_t i ;

	//Initialize ADC
	InitADC() ;
	DDRC = 0xff ;
	while (1) {
		// citeste valoarea analoaga de pe canalul 0
		adc_result = ReadADC(0) ;

		int setat_ventilator = 0, setat_led = 0, setat_buzzer = 0 ;
		// scot 5V pe PC5
		if ( 280 <= adc_result && adc_result < 285 ) {
			setat_ventilator = 1 ;
			if ( setat_buzzer == 1 ) {
				bit_clr(PORTC,PC3) ;
				setat_buzzer = 0 ;
			}
			if ( setat_led == 1 ) {
				bit_clr(PORTC,PC4) ;
				setat_led = 0 ;
			}
			bit_set(PORTC,PC5) ;
		}
		// scot 5V pe PC4
		if ( 285 <= adc_result && adc_result < 287 ) {
			setat_led = 1 ;
			if ( setat_buzzer == 1 ) {
				bit_clr(PORTC,PC3) ;
				setat_buzzer = 0 ;
			}
			bit_set(PORTC,PC4) ;
		}
			
		// scot 5V pe PC3 -> in if-ul asta intra la temperatura camerei
		if ( 290 <= adc_result && adc_result < 320 ) {
			setat_buzzer = 1 ;
			bit_set(PORTC,PC3) ;
		}

		// PC4 = led, PC5 = ventilator, PC3 = buzzer

		// asteptare
		for ( i = 0 ; i < 20 ; ++i )
			_delay_loop_2(0) ;
	}
	return 0 ;
}
